<?php

/**
 * ab Calendar Generation Class
 *
 * @author post[at]agile-websites[dot]de Wolfgang Bund
 * @link http://agile-websites.de
 * @package redaxo 4.6.1
 * @version $Id: class.abcalendar.inc.php,v 0.1 2015/03/19 12:46:00
 */
class abcalendar {

   var $months = array('Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember');
   var $weekdays = array('Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa', 'So');
   var $month;
   var $year;
   var $baselink = 'index.php?page=abcalendar';
   var $mailTo;
   var $bookingTemplate = 'booking';
   var $bookingConfirmTemplate = 'booking_confirm';
   var $confirmPage = 0;
   var $objectId = 1;
   var $objectName = '';
   var $xform;

   function __construct($object_id = null, $date = null, $year = null, $month = null) {
      global $REX;
      $this->month = ($m = rex_request('month', 'int', 0)) ? $m : date('m');
      $this->year = ($y = rex_request('year', 'int', 0)) ? $y : date('Y');
      // Im Frontend Blick zurück verhindern
      if ($REX['GG']) {
         if (($y.'-'. str_pad($m,2,'0',STR_PAD_LEFT)) < date('Y-m')) {
            $this->month = date('m');
            $this->year = date('Y');
         }
      }
   }

   public function getCalendar() {
      return self::get12Months();
   }

   private function get12Months() {
      $year = $this->year;
      $month = $this->month;
      $dt = new DateTime();
      $dt->setDate($this->year, $this->month, 1);
      $out = '';
      $out .= $this->getNavigation();
      $n = 1;
      while ($n <= 12) {
         $out .= self::getMonth($year, $month);
         $month ++;
         if ($month > 12) {
            $month = 1;
            $year ++;
         }
         $n++;
      }

      return $out;
   }

   private function getMonth($year = 0, $month = 0) {
      if (!$year)
         $year = date('Y');
      if (!$month)
         $month = date('m');
      $dt = new DateTime();
      $dt->setDate($year, $month, 1);
      $firstDayOfMonth = $dt->format('N');
      $daysInMonth = $dt->format('t');

      $bookings = $this->getBookingsForMonth($year, $month, $dt);
//      out(array($bookings),1);

      $out = '<ul class="abc_month">';
      $out .= '<li class="abc_month_title">' . $this->months[$month - 1] . ' ' . $year . '</li>';
      foreach ($this->weekdays as $wd) {
         $out .= '<li class="abc_day abc_weekday">' . $wd . '</li>';
      }
      $out .= str_repeat('<li class="abc_dummy abc_day">&nbsp;</li>', ($firstDayOfMonth - 1));
      $day = 1;
      while ($day <= $daysInMonth) {
         $date = $year . '-' . $dt->format('m') . '-' . str_pad($day, 2, '0', STR_PAD_LEFT);
         $bookingData = $this->getBookingDataForDate($date, $bookings);
         $out .= '<li class="abc_day '.$bookingData['class'].'" data-date="' . $date . '" data-bookingid="'.$bookingData['bookingId'].'">' . $day . '</li>';
         $day++;
      }
      $out .= '</ul>';
      return $out;
   }
   
   private function getBookingDataForDate ($date, $bookings) {
      $class = array();
      $bookingId = 0;
      foreach ($bookings as $booking) {
         if ($booking['day'] == $date) {
            $bookingId = $booking['id'];
            $class['fixbooked'] = 'fixbooked';
            if ($booking['type'] == 'start') {
               $class['fixbooked-first'] = 'fixbooked-first';
            } elseif ($booking['type'] == 'end') {
               $class['fixbooked-last'] = 'fixbooked-last';
            }
         }
      }
      if (rex_request('datefrom') && rex_request('dateto')) {
         if (rex_request('datefrom') == $date  && !isset($class['fixbooked-first'])) {
            $class['booked'] = 'booked';
            $class['booked-first'] = 'booked-first';
         }
         if (rex_request('dateto') == $date  && !isset($class['fixbooked-last'])) {
            $class['booked'] = 'booked';
            $class['booked-last'] = 'booked-last';
         }
         if ($date > rex_request('datefrom') && $date < rex_request('dateto')) {
            $class['booked'] = 'booked';
         }
      }
      return array('class'=>implode(' ',$class),'bookingId'=>$bookingId);
   }

   private function getBookingsForMonth($year, $month, $dt) {
      global $REX;
      
      $objWhere = ($this->objectId) ? ' AND objectid = '.$this->objectId.' ' : '' ;
      
      $bookings = array();
      
      $startDate = $dt->format('Y-m-d');
      $endDate = $year.'-'.str_pad($month,2,'0',STR_PAD_LEFT).'-'.$dt->format('t');
      
      $sql = new rex_sql();
      $sql->debugsql = 0;
      $qry = 'SELECT * FROM ' . $REX['TABLE_PREFIX'] . 'abcalendar '
            . 'WHERE (storno = "0" OR storno = "" OR storno IS NULL) AND ((datefrom >= "'.$startDate.'" AND datefrom <= "'.$endDate.'") '
            . 'OR (dateto >= "'.$startDate.'" AND dateto <= "'.$endDate.'") '
            . 'OR (datefrom <= "'.$startDate.'" AND dateto >= "'.$endDate.'")) '
            . $objWhere
            . ' ORDER BY datefrom';
      $sql->setQuery($qry);
      $res = $sql->getArray();
      foreach ($res as $date) {
         $oAnreise = new DateTime($date['datefrom']);
         $oAbreise = new DateTime($date['dateto']);
         $oAbreise->modify('+1 day');
         $period = new DatePeriod( $oAnreise , new DateInterval('P1D'), $oAbreise );
         $period = iterator_to_array($period);
         foreach ($period as $i=>$day) {
            $_p = array();
            $_p['day'] = $day->format('Y-m-d');
            $_p['type'] = 'full';
            $_p['id'] = $date['id'];
            if ($i == 0) $_p['type'] = 'start'; 
            if (($i+1) == sizeof($period)) $_p['type'] = 'end'; 
            $bookings[] = $_p;
         }
      }
      return $bookings;
   }

   private function getNavigation() {
      global $REX;
      
      $deli = (strpos($this->baselink,'?')) ? '&' : '?';
      
      if ($this->month == 1) {
         $prevMonth = 12;
         $prevYear = $this->year - 1;
      } else {
         $prevMonth = $this->month - 1;
         $prevYear = $this->year;
      }
      if ($this->month == 12) {
         $nextMonth = 1;
         $nextYear = $this->year + 1;
      } else {
         $nextMonth = $this->month + 1;
         $nextYear = $this->year;
      }
      
      $backlink = '<a href="' . $this->baselink . $deli . 'year=' . ($this->year - 1) . '&month=' . $this->month . '&objectid='.$this->objectId.'">&lt;&lt; ' . $this->months[$this->month - 1] . ' ' . ($this->year - 1) . '</a>&nbsp;|&nbsp;';
      $backlink .= '<a href="' . $this->baselink . $deli . 'year=' . $prevYear . '&month=' . $prevMonth . '&objectid='.$this->objectId.'">&lt; ' . $this->months[$prevMonth - 1] . ' ' . $prevYear . '</a>';
      
      if ($REX['GG'] && ($this->year.'-'. str_pad($this->month,2,'0',STR_PAD_LEFT)) <= date('Y-m')) {
         $backlink = '';
      }

      
      $out = '<nav class="abc_pager_nav">';

      $out .= '<div class="fl-left">';
      $out .= $backlink;
      $out .= '</div>';

      $out .= '<div class="fl-right">';
      $out .= '<a href="' . $this->baselink . $deli . 'year=' . $nextYear . '&month=' . $nextMonth . '&objectid='.$this->objectId.'">' . $this->months[($nextMonth + 10) % 12] . ' ' . ($this->year + 1) . ' &gt;</a>&nbsp;|&nbsp;';
      $out .= '<a href="' . $this->baselink . $deli . 'year=' . ($this->year + 1) . '&month=' . $this->month . '&objectid='.$this->objectId.'">' . $this->months[($this->month + 10) % 12] . ' ' . ($this->year + 2) . ' &gt;&gt;</a>';
      $out .= '</div>';

      $out .= '</nav>';
      return $out;
   }

   public static function appendToPageHeader($params) {
      $insert = '<!-- BEGIN abcalendar -->' . PHP_EOL;
      $insert .= '<link rel="stylesheet" type="text/css" href="../' . self::getMediaAddonDir() . '/abcalendar/abcalendar.css" />' . PHP_EOL;
      $insert .= '<script type="text/javascript" src="../' . self::getMediaAddonDir() . '/abcalendar/abcalendar.js"></script>' . PHP_EOL;
      $insert .= '<!-- END abcalendar -->';

      return $params['subject'] . PHP_EOL . $insert;
   }

   public static function getMediaAddonDir() {
      global $REX;

      // check for media addon dir var introduced in REX 4.5
      if (isset($REX['MEDIA_ADDON_DIR'])) {
         return $REX['MEDIA_ADDON_DIR'];
      } else {
         return 'files/addons';
      }
   }

   public function getBookingForm() {
      global $REX;
      
      $form = rex_request('FORM','array');
      $send = (isset($form['formular']['send']) && $form['formular']['send']) ? true : false;
      
      $this->xform = new rex_xform();
      $this->xform->setObjectparams('debug', 0);
      $this->xform->setValueField('text', array('vorname', 'Vorname'));
      $this->xform->setValueField('text', array('nachname', 'Nachname'));
      $this->xform->setValueField('text', array('name', 'Name', '', 'no_db'));
      $this->xform->setValueField('text', array('anschrift', 'Anschrift'));
      $this->xform->setValueField('text', array('plzort', 'PLZ/Ort'));
      $this->xform->setValueField('text', array('telefon', 'Telefon'));
      $this->xform->setValueField('text', array('email', 'Email'));
      $this->xform->setValueField('text', array('anreise', 'Anreise', '', 'no_db'));
      $this->xform->setValueField('text', array('abreise', 'Abreise', '', 'no_db'));
      $this->xform->setValueField('text', array('personen', 'Anzahl Personen'));
      $this->xform->setValueField('text', array('anreisezeit', 'Anreisezeit'));
      $this->xform->setValueField('textarea', array('nachricht', 'Nachricht'));

      $this->xform->setValueField('hidden', array('datefrom', 'datefrom', 'REQUEST'));
      $this->xform->setValueField('hidden', array('dateto', 'dateto', 'REQUEST'));
      if ($this->objectId && class_exists('abcobjects')) {
         $this->xform->setValueField('hidden', array('objectid', $this->objectId, 'REQUEST'));
         $this->xform->setValueField('hidden', array('objectname', $this->objectName, 'REQUEST'));
      } else {
         $this->xform->setValueField('hidden', array('objectid', 1, 'REQUEST'));
         $this->xform->setValueField('hidden', array('objectname', '', '', 'no_db'));
      }
      if ($REX['REDAXO']) {
//	     $this->xform->setValueField('text', array('storno', 'Storno'));
         $this->xform->setValueField('text', array('bookingdate', 'Buchungsdatum',date('Y-m-d')));
      } else {
         $this->xform->setValueField('datestamp', array('bookingdate', 'Y-m-d','',1));
      }
      
      
      $this->xform->setValueField('submit', array('submit_form','Absenden','no_db','submitbutton','submitit'));

      $this->xform->setValidateField('empty', array('vorname', 'Bitte alles ausfüllen.'));
      $this->xform->setValidateField('empty', array('nachname', 'Bitte alles ausfüllen.'));
      $this->xform->setValidateField('empty', array('email', 'Bitte alles ausfüllen.'));
      $this->xform->setValidateField('empty', array('anreise', 'Bitte alles ausfüllen.'));
      $this->xform->setValidateField('empty', array('abreise', 'Bitte alles ausfüllen.'));
      
      $this->xform->setObjectparams("form_action", $this->baselink);
      if ($REX['REDAXO']) {
         $this->xform->setObjectparams("form_showformafterupdate", true);
      }
      
//      $this->xform->setObjectparams("debug", true);
      
      $this->xform->setObjectparams("answertext", '<p>Formular wurde gespeichert.</p>');

      $this->xform->setObjectparams("form_wrap_id", 'abcalendar-form');
      if ($send) {
         $this->xform->setObjectparams("form_wrap_class", 'xform has_errors');
      }
      
      $this->xform->setValidateField('check_abcbooking', array('','datefrom','dateto','Für dieses Datum besteht bereits eine Buchung. Bitte wählen Sie ein anderes Datum.'));
      
      $this->xform->setActionField('db', array($REX['TABLE_PREFIX'] . 'abcalendar'));
      
      // Mails nur im Frontend schicken
      // Weiterleitung nur im Frontend

      if ($REX['GG']) {
         $this->xform->setActionField('db2email_honeypot', array($this->bookingConfirmTemplate,'email','','name'));
         if ($this->mailTo) {
            $this->xform->setActionField('db2email_honeypot', array($this->bookingTemplate,'',$this->mailTo,'name'));
         }

         if ($this->confirmPage) {
            $this->xform->setActionField('redirect',array($this->confirmPage));
         }
      }

      return $this->xform->getForm();
   }
   
   public static function checkIfDateIsBooked ($anreise = '', $abreise = '',$objectid = 0) {
      global $REX;
         
         $sql = new rex_sql();
         $qry = 'SELECT * FROM ' . $REX['TABLE_PREFIX'] . 'abcalendar '
               . 'WHERE (storno = "0" OR storno = "" OR storno IS NULL) AND ((dateto > "' . $anreise . '" AND dateto < "' . $abreise . '") '
               . 'OR (datefrom > "' . $anreise . '" AND datefrom < "' . $abreise . '") '
               . 'OR (datefrom <= "' . $anreise . '" AND dateto >= "' . $abreise . '")) ';
         if ($objectid) {
            $qry .= ' AND objectid = '.$objectid;
         }
         $sql->debugsql = 0;
         $sql->setQuery($qry);
         $res = $sql->getArray();

         $booked = 0;
         if ($res)
            $booked = 1;
         
         return 0;

   }

}
