<div class="rex-addon-output">
    <h2 class="rex-hl2"><?php echo $I18N->msg('abcalendar_buchungen'); ?></h2>
</div>
<style>
    .rex-addon-output span {
        display: none;
    }
    .rex-addon-output span:first-child {
        display: inline;
    }
    .abcalendar-output a {
        display: inline-block;
        padding: 5px;
    }
    .abcalendar-output a.active {
        font-weight: bold;
    }
</style>

<?php

function filter_for_next_arrival ($params) {
   global $REX;
   $search = 'from `'.$REX['TABLE_PREFIX'].'abcalendar` t0 where';
   if (strpos($params['subject'],$search)) {
      $sql = explode($search,$params['subject']);
      $sql = implode($search.' datefrom > "'.date('Y-m-d').'" AND ', $sql);
   } else {
      $sql = substr($params['subject'],0,strpos($params['subject'],'ORDER BY'));
      $sql .= ' WHERE datefrom > "'.date('Y-m-d').'" ORDER BY `datefrom` ASC';      
   }
   return $sql;
}

function filter_for_last_bookings ($params) {
   $sql = substr($params['subject'],0,strpos($params['subject'],'ORDER BY'));
   $sql .= ' ORDER BY `id` DESC';      
   return $sql;
}

function link_to_all ($params) {
   $links = array(
      1 => array('caption'=>'Alle anzeigen','class'=>'std'),
      2 => array('caption'=>'nächste Anreisen','class'=>'std'),
      3 => array('caption'=>'neueste Buchungen','class'=>'std'),      
   );
   if ($k = rex_session('abc_filter','int',0)) {
        $links[$k]['class'] = 'active';
   }
   $out = array();
   foreach ($links as $k=>$link) {
      $out[] = '<a href="'.$params['subject']->getUrl(array('abcctrl'=>$k)).'" class="'.$link['class'].'">'.$link['caption'].'</a>';
   }
   
   
   echo '<div class="rex-addon-output abcalendar-output">';
   echo '<p>';
   echo implode(' | ',$out);
   echo '</p>';
   echo '</div>';
   return;
}

if ($v = rex_request('abcctrl','int',0)) {
   rex_set_session('abc_filter',$v);
}

if (rex_session('abc_filter','int',0) == 2) {
   rex_register_extension('XFORM_DATA_LIST_SQL','filter_for_next_arrival');   // Ergebnisse Filtern   
}
if (rex_session('abc_filter','int',0) == 3) {
   rex_register_extension('XFORM_DATA_LIST_SQL','filter_for_last_bookings');   // Ergebnisse Filtern   
}

rex_register_extension('XFORM_DATA_LIST','link_to_all'); // Links anzeigen

$table = $REX['TABLE_PREFIX'] . 'abcalendar';

$table = new rex_xform_manager_table(array(
   'table_name'=>$table,
   'search'=>1,
   'name'=>'Buchungen',
   'list_sortfield'=>'datefrom',
   'list_sortorder'=>'ASC',
   'export'=>0,
   'import'=>0,
   'id'=>'id',
   ));

$xform = new rex_xform_manager();
$xform->setTable($table);
$xform->setLinkVars(array('page'=>'abcalendar','subpage'=>'bookings','table_name'=>$table));
$xform->setDataPageFunctions(array('search','delete'));
$xform->setFilterFields(array('vorname','nachname'));
$xform->getDataPage();

echo '</div>';

