<div class="rex-addon-output">
    <h2 class="rex-hl2"><?php echo $I18N->msg('abcalendar_anleitung'); ?></h2>

    <div class="rex-addon-content">
        <div class="addon-template">
            <h1>Anleitung</h1>
            <h2>1. Installation</h2>
            <p>Für die Installation kopieren Sie das Addon ins Addon-Verzeichnis von Redaxo, installieren es und aktivieren es. Dies haben Sie vermutlich bereits getan.</p>
            <p>Das Addon bringt alle notwendigen Komponenten mit, damit ein lauffähiges Buchungssystem installiert werden kann.</p>
            <p>Die Komponenten sind:</p>
            <ul>
                <li>Datentabelle für die Buchungen</li>
                <li>Inhaltsmodul</li>
                <li>E-Mail Templates für die Buchungen und die Buchungsbestätigungen</li>
                <li>Verwaltungsmöglichkeit für Buchungen (anzeigen, stornieren, löschen, manuell erfassen)</li>            
                <li>CSS und Javascript Dateien</li>            
            </ul>
            <p>Auf der Seite "Setup" dieses Addons können Sie das Inhaltsmodul und die E-Mail Templates installieren.</p>
            <p>Für das Frontend ist Voraussetzung, dass jquery installiert ist.</p>
            <p>Hier ist ein Minimaltemplate für die Ausgabe, in dem die vom Addon bereitgestellten js und css Dateien bereits eingebunden sind:</p>
            <code>
                &lt;html&gt;<br>
                  &lt;head&gt;<br>
                  &lt;meta charset="utf-8" /&gt;<br>
                  &lt;title&gt;&lt;?= $this-&gt;getValue('name') .' | '. $REX['SERVERNAME'] ?&gt;&lt;/title&gt;<br>
                  &lt;link rel="stylesheet" type="text/css" href="files/addons/abcalendar/abcalendar.css" media="all" /&gt;&lt;/head&gt;<br>
                  &lt;link rel="stylesheet" type="text/css" href="files/addons/abcalendar/abcalendar_fe.css" media="all" /&gt;&lt;/head&gt;<br>
                  &lt;body class="js"&gt;<br>
                  &lt;?= $this-&gt;getArticle(); ?&gt;<br>
                     &lt;script src="//ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"&gt;&lt;/script&gt;<br>
                     &lt;script&gt;window.jQuery || document.write('&lt;script src="resources/js/vendor/jquery-1.10.2.min.js"&gt;&lt;\/script&gt;')&lt;/script&gt;<br>
                     &lt;script src="files/addons/abcalendar/abcalendar.js"&gt;&lt;/script&gt;<br>
                  &lt;/body&gt;<br>
               &lt;/html&gt;<br><br>
            </code>
            <p>Fügen Sie als nächstes das Inhaltsmodul <i>ab-calendar</i> in eine Inhaltsseite ein und nehmen Sie die gewünschten Einstellungen vor. Eine Bestätigungsseite ist optional und kann auch später noch angelegt werden. Im Frontend können Sie nun den Kalender bereits aufrufen.</p>
            <p>Nun müssen Sie noch die E-Mail Templates Ihren Anforderungen anpassen. Rufen Sie diese über die Verwaltung von xform / E-Mail Templates auf und nehmen Sie die gewünschten Änderungen vor. Benennen Sie keine Platzhalter um. Platzhalter sind durch ###platzhaltername### gekennzeichnet.</p>
            <p>Sie können nun über das Frontend eine Buchung vornehmen. Die Buchung sollte ihnen als E-Mail zugestellt werden und im Belegungskalender erscheinen. Damit ist die Installation erfolgreich abgeschlossen.</p>
            <p>Das Buchungsformular ist mit einem Spamschutz (Honeypot) versehen. Hierfür wird das Feld <i>name</i> verwendet. Dieses Feld wird per css unsichtbar gemacht. Wenn das Feld ausgefüllt wird, so wird keine E-Mail verschickt.</p>
            
            <h2>2. Einen Termin buchen</h2>
            <p>Eine Terminbuchung im Frontend und im Backend ist intuitiv und selbsterklärend auf dem Bildschirm. Zunächst wird per Klick auf ein Datum ein Anreisetag gewählt. Der zweite Klick wählt entweder das Abreisedatum oder ein neues Anreisedatum. Ist der Buchungszeitraum gewählt, erscheint das Buchungsformular. Die Buchung wird mit dem Absenden des Formulars abgeschlossen.</p>
            <p>Eine Buchung kann nur im Backend geändert, storniert oder gelöscht werden. Eine Buchung kann entweder über den Kalender aufgerufen werden. Wenn mit Shift+Klick auf einen gebuchten Zeitraum geklickt wird, wird die Buchung aufgerufen. Eine Buchung kann auch über die Buchungsliste bearbeitet werden.</p>
            
            <h2>3. Einen Buchungstermin bearbeiten</h2>
            <p>Ein Buchungstermin kann entweder aus dem Kalender im Backend oder über die Buchungsliste aufgerufen werden. Aus dem Kalender kann die Buchung über Shift+Klick (Umschalttaste festhalten und auf einen Termin klicken) aufgerufen werden. Bei mehreren Objekten kann der Kalender zum jeweiligen Objekt umgeschaltet werden.</p>
            <p>In der Buchungsliste kann ein Termin über den Link <i>editieren</i> aufgerufen und bearbeitet werden. Die Buchungsliste kann über die Suchfunktion nach Namen, Ort und Objekt durchsucht werden. Alternativ gibt es einen Quicklink "nächste Anreisen" und "neueste Buchungen".</p>
            
            <h2>4. Support</h2>
            <p>Wolfgang Bund<br>Am Tressower See 1<br>23966 Tressow<br><a href="mailto:post@agile-webistes.de">post@agile-websites.de</a><br><a href="http://agile-websites.de">agile-websites.de</a></p>
            <h2>5. Ideen</h2>
            <p>Als Erweiterung für den ab calendar gibt es noch ein paar Ideen, die noch nicht umgesetzt sind. Hier einmal eine unvollständige Aufstellung:</p>
            <ul>
               <li>Verwaltung und Berechnung von Preisen</li>
               <li>Newsletter, z.B. für Schnäppchenangebote und Last-minute</li>
               <li>Shopfunktion für Extras, z.B. Wäschepaket, zusätzliche Personen, Hund usw.</li>
               <li>Mindestbuchungszeiträume frei definierbar</li>
               <li>Mehrsprachigkeit</li>
               <li>Ihre Idee oder Ihre Wünsche? - Fragen Sie bitte an.</li>
            </ul>
            
            <h2>Lizenz</h2>
            <p>Copyright (c) 2015 Wolfgang Bund</p>
<p>Das Addon ab-calendar wird unter der MIT Lizenz vertrieben.</p>
<p>Hiermit wird unentgeltlich, jeder Person, die eine Kopie der Software und der zugehörigen Dokumentationen (die "Software") erhält, die Erlaubnis erteilt, sie uneingeschränkt zu benutzen, inklusive und ohne Ausnahme, dem Recht, sie zu verwenden, kopieren, ändern, fusionieren, verlegen, verbreiten, unterlizenzieren und/oder zu verkaufen, und Personen, die diese Software erhalten, diese Rechte zu geben, unter den folgenden Bedingungen:</p>
<p>Der obige Urheberrechtsvermerk und dieser Erlaubnisvermerk sind in allen Kopien oder Teilkopien der Software beizulegen.</p>
<p>DIE SOFTWARE WIRD OHNE JEDE AUSDRÜCKLICHE ODER IMPLIZIERTE GARANTIE BEREITGESTELLT, EINSCHLIESSLICH DER GARANTIE ZUR BENUTZUNG FÜR DEN VORGESEHENEN ODER EINEM BESTIMMTEN ZWECK SOWIE JEGLICHER RECHTSVERLETZUNG, JEDOCH NICHT DARAUF BESCHRÄNKT. IN KEINEM FALL SIND DIE AUTOREN ODER COPYRIGHTINHABER FÜR JEGLICHEN SCHADEN ODER SONSTIGE ANSPRÜCHE HAFTBAR ZU MACHEN, OB INFOLGE DER ERFÜLLUNG EINES VERTRAGES, EINES DELIKTES ODER ANDERS IM ZUSAMMENHANG MIT DER SOFTWARE ODER SONSTIGER VERWENDUNG DER SOFTWARE ENTSTANDEN.</p>
<p>Deutsche Übersetzung aus der Wikipedia</p>

        </div>
    </div>

</div>

