<?php

class rex_xform_validate_check_abcbooking extends rex_xform_validate_abstract {
   /*
    * Überprüft, ob für das gewählte Datum bereits ein Eintrag im Buchungskalender vorliegt
    * Dabei werden alle Tage aus dem gewählten Zeitraum mit den in diesem Zeitraum gebuchten
    * Tage aus dem Kalender verglichen.
    * Belegungswechsel an einem Tag wird akzeptiert.
    */

   function enterObject() {
      global $REX;
      if ($this->params["send"] == "1") {
         $anreise = $this->getElement(3);
         $abreise = $this->getElement(4);
         $objectId = 0;

         foreach ($this->obj as $o) {
            if ($o->getName() == $anreise)
               $anreise = $o->getValue();
            if ($o->getName() == $abreise)
               $abreise = $o->getValue();
            if ($o->getName() == 'objectid')
               $objectid = $o->getValue();
         }
         
         $booked = abcalendar::checkIfDateIsBooked($anreise,$abreise);


         if ($booked) {
            $this->params["warning"][$this->getElement(3)] = $this->params["error_class"];
            $this->params["warning"][$this->getElement(4)] = $this->params["error_class"];
            $this->params["warning_messages"][$this->getElement(2)] = $this->getElement(5);
         }
      }
   }

   function getDescription() {
      return "check_abcbooking -> prüft über customfunc, beispiel: validate|check_abcbooking||datefrom|dateto|warning_message";
   }

   function getDefinitions() {
      return array(
         'type' => 'validate',
         'name' => 'check_booking',
         'values' => array(
            array('type' => 'select_name', 'label' => 'Name'),
            array('type' => 'text', 'label' => 'Name der Funktion'),
            array('type' => 'text', 'label' => 'Weitere Parameter'),
            array('type' => 'text', 'label' => 'Fehlermeldung'),
         ),
         'description' => 'Mit eigener Funktion vergleichen',
      );
   }

}

?>